diff -ruN vdr-1.3.46/spu.c vdr-1.3.47/spu.c
--- vdr-1.3.46/spu.c	2006-03-26 16:07:59.000000000 +0200
+++ vdr-1.3.47/spu.c	2006-04-17 14:48:33.000000000 +0200
@@ -6,13 +6,13 @@
  * This code is distributed under the terms and conditions of the
  * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
  *
- * $Id: spu.c 1.2 2006/03/26 14:07:59 kls Exp $
+ * $Id: spu.c 1.3 2006/04/17 12:48:33 kls Exp $
  */
 
 #include "spu.h"
 #include <inttypes.h>
 
-// -- cSpuDecoder ----------------
+// -- cSpuDecoder ------------------------------------------------------------
 /*
 cSpuDecoder::cSpuDecoder()
 {};
diff -ruN vdr-1.3.46/spu.h vdr-1.3.47/spu.h
--- vdr-1.3.46/spu.h	2005-02-20 12:21:31.000000000 +0100
+++ vdr-1.3.47/spu.h	2006-04-17 14:48:55.000000000 +0200
@@ -6,7 +6,7 @@
  * This code is distributed under the terms and conditions of the
  * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
  *
- * $Id: spu.h 1.4 2005/02/20 11:21:31 kls Exp $
+ * $Id: spu.h 1.5 2006/04/17 12:48:55 kls Exp $
  */
 
 #ifndef __SPU_VDR_H
@@ -14,7 +14,7 @@
 
 #include <inttypes.h>
 
-// --- cSpuDecoder -------------------------------------------
+// --- cSpuDecoder -----------------------------------------------------------
 
 class cSpuDecoder {
   public:
diff -ruN vdr-1.3.46/summary2info.pl vdr-1.3.47/summary2info.pl
--- vdr-1.3.46/summary2info.pl	2005-09-17 11:20:31.000000000 +0200
+++ vdr-1.3.47/summary2info.pl	2006-04-17 14:19:24.000000000 +0200
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: summary2info.pl 1.5 2005/09/17 09:20:31 kls Exp $
+# $Id: summary2info.pl 1.6 2006/04/17 12:19:24 kls Exp $
 
 $VideoDir = $ARGV[0] || die "please provide the name of the video directory\n";
 
@@ -41,7 +41,7 @@
        # if line 1 is too long, it can't be the short text,
        # so assume the short text is missing and concatenate
        # line 1 and line 2 to be the long text:
-       if (length($data[1]) > 80) { 
+       if (length($data[1]) > 80) {
           $data[2] = $data[1] . "|" . $data[2];
           $data[1] = "";
           }
diff -ruN vdr-1.3.46/svdrp.c vdr-1.3.47/svdrp.c
--- vdr-1.3.46/svdrp.c	2006-03-26 11:14:13.000000000 +0200
+++ vdr-1.3.47/svdrp.c	2006-04-17 11:02:23.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.94 2006/03/26 09:14:13 kls Exp $
+ * $Id: svdrp.c 1.95 2006/04/17 09:02:23 kls Exp $
  */
 
 #include "svdrp.h"
@@ -1351,8 +1351,10 @@
               }
            }
         else if (strcasecmp(cmd, "MAIN") == 0) {
-           cRemote::CallPlugin(plugin->Name());
-           Reply(250, "Initiated call to main menu function of plugin \"%s\"", plugin->Name());
+           if (cRemote::CallPlugin(plugin->Name()))
+              Reply(250, "Initiated call to main menu function of plugin \"%s\"", plugin->Name());
+           else
+              Reply(550, "A plugin call is already pending - please try again later");
            }
         else {
            int ReplyCode = 900;
diff -ruN vdr-1.3.46/tools.c vdr-1.3.47/tools.c
--- vdr-1.3.46/tools.c	2006-03-19 13:28:16.000000000 +0100
+++ vdr-1.3.47/tools.c	2006-04-17 14:19:31.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.115 2006/03/19 12:28:16 kls Exp $
+ * $Id: tools.c 1.116 2006/04/17 12:19:31 kls Exp $
  */
 
 #include "tools.h"
@@ -39,7 +39,7 @@
   snprintf(fmt, sizeof(fmt), "[%d] %s", cThread::ThreadId(), format);
   va_start(ap, format);
   vsyslog(priority, fmt, ap);
-  va_end(ap); 
+  va_end(ap);
 }
 
 int BCD2INT(int x)
diff -ruN vdr-1.3.46/tools.h vdr-1.3.47/tools.h
--- vdr-1.3.46/tools.h	2006-02-04 15:27:05.000000000 +0100
+++ vdr-1.3.47/tools.h	2006-04-16 12:40:45.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.92 2006/02/04 14:27:05 kls Exp $
+ * $Id: tools.h 1.93 2006/04/16 10:40:45 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -52,7 +52,7 @@
 template<class T> inline void swap(T &a, T &b) { T t = a; a = b; b = t; }
 #endif
 
-void syslog_with_tid(int priority, const char *format, ...);
+void syslog_with_tid(int priority, const char *format, ...) __attribute__ ((format (printf, 2, 3)));
 
 #define BCDCHARTOINT(x) (10 * ((x & 0xF0) >> 4) + (x & 0xF))
 int BCD2INT(int x);
diff -ruN vdr-1.3.46/vdr.c vdr-1.3.47/vdr.c
--- vdr-1.3.46/vdr.c	2006-04-09 14:22:46.000000000 +0200
+++ vdr-1.3.47/vdr.c	2006-04-17 16:43:46.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.254 2006/04/09 12:22:46 kls Exp $
+ * $Id: vdr.c 1.262 2006/04/17 14:43:46 kls Exp $
  */
 
 #include <getopt.h>
@@ -346,7 +346,7 @@
 
   // Set user id in case we were started as root:
 
-  if (VdrUser && getuid() == 0) {
+  if (VdrUser && geteuid() == 0) {
      StartedAsRoot = true;
      if (strcmp(VdrUser, "root")) {
         if (!SetKeepCaps(true))
@@ -980,6 +980,8 @@
                           if (Interface->Confirm(tr("Recording - shut down anyway?")))
                              ForceShutdown = true;
                           }
+                       if (cPluginManager::Active(tr("shut down anyway?")))
+                          ForceShutdown = true;
                        LastActivity = 1; // not 0, see below!
                        UserShutdown = true;
                        break;
@@ -1051,6 +1053,7 @@
               }
            switch (key) {
              // Toggle channels:
+             case kChanPrev:
              case k0: {
                   if (PreviousChannel[PreviousChannelIndex ^ 1] == LastChannel || LastChannel != PreviousChannel[0] && LastChannel != PreviousChannel[1])
                      PreviousChannelIndex ^= 1;
@@ -1059,11 +1062,16 @@
                   }
              // Direct Channel Select:
              case k1 ... k9:
-             // Left/Right rotates trough channel groups:
+             // Left/Right rotates through channel groups:
              case kLeft|k_Repeat:
              case kLeft:
              case kRight|k_Repeat:
              case kRight:
+             // Previous/Next rotates through channel groups:
+             case kPrev|k_Repeat:
+             case kPrev:
+             case kNext|k_Repeat:
+             case kNext:
              // Up/Down Channel Select:
              case kUp|k_Repeat:
              case kUp:
@@ -1093,7 +1101,7 @@
                  Skins.Message(mtInfo, tr("Editing process finished"));
               }
            }
-        if (!Interact && ((!cRecordControls::Active() && !cCutter::Active() && (!Interface->HasSVDRPConnection() || UserShutdown)) || ForceShutdown)) {
+        if (!Interact && ((!cRecordControls::Active() && !cCutter::Active() && !cPluginManager::Active() && (!Interface->HasSVDRPConnection() || UserShutdown)) || ForceShutdown)) {
            time_t Now = time(NULL);
            if (Now - LastActivity > ACTIVITYTIMEOUT) {
               // Shutdown:
@@ -1130,7 +1138,8 @@
                        cControl::Shutdown();
                        int Channel = timer ? timer->Channel()->Number() : 0;
                        const char *File = timer ? timer->File() : "";
-                       Delta = Next - time(NULL); // compensates for Confirm() timeout
+                       if (timer)
+                          Delta = Next - time(NULL); // compensates for Confirm() timeout
                        char *cmd;
                        asprintf(&cmd, "%s %ld %ld %d \"%s\" %d", Shutdown, Next, Delta, Channel, *strescape(File, "\"$"), UserShutdown);
                        isyslog("executing '%s'", cmd);
@@ -1157,6 +1166,8 @@
               PluginManager.Housekeeping();
               }
            }
+        // Main thread hooks of plugins:
+        PluginManager.MainThreadHook();
         }
   if (Interrupted)
      isyslog("caught signal %d", Interrupted);
@@ -1179,7 +1190,7 @@
      Setup.Save();
      }
   cDevice::Shutdown();
-  PluginManager.Shutdown();
+  PluginManager.Shutdown(true);
   cSchedules::Cleanup(true);
   ReportEpgBugFixStats();
   if (WatchdogTimeout > 0)
